#ifndef TOMTOM_SOUND_DRIVER_H
#define TOMTOM_SOUND_DRIVER_H

#include <linux/completion.h> 


#ifdef SDEBUG_T
#define D(x) x
#define trace(x) printk("%s\n", __FUNCTION__)
#else
#define D(x)
#define trace(x)
#endif

#define BUFFER_SIZE (64 * 1024)

#define printk(msg ...) {}

#define USE_FS256

struct iis_dma {
	void *		virt_address;
	dma_addr_t	phys_address;

	unsigned int mmapped_size;
	struct completion comp;
	spinlock_t dma_lock;
};

struct iis_attached_ops {
	int (*set_volume)(unsigned int);
	int (*set_volume_internal)(unsigned int);
	int (*set_volume_external)(unsigned int);
	int (*set_register)(unsigned int);
	void (*suspend)(void);
	void (*resume)(void);
	int (*set_treble)(unsigned int);
	int (*set_bass)(unsigned int);
};

#endif
