#ifndef S3C2410_IIS_SND
#define S3C2410_IIS_SND

#include <linux/types.h> 

typedef enum {
	IIS_IDLE_TX,
	IIS_IDLE_RX,
	IIS_ACTIVE_TX,
	IIS_ACTIVE_RX,
	IIS_ALIGN_TX,
	IIS_ALIGN_RX,
	IIS_FLUSH_RX,
	IIS_FLUSH_TX,
	IIS_START,
	IIS_STOP
} iis_cmd_t;

int 		iis_init(void);
void 		iis_control_cmd(iis_cmd_t command);

void 		iis_suspend(void);
void 		iis_resume(void);

int 		iis_set_samplerate(unsigned int rate);
unsigned int 	iis_get_samplerate(void);

int 		iis_set_samplesize(unsigned int size);
unsigned int 	iis_get_samplesize(void);

void 		iis_showbus(const char *);

#endif /* S3C2410_IIS_SND */
