/*1**************************************************************************
  Project          : TomTom Barcelona
  Proj. Supervisor : Sharath Narayana
  --------------------------------------------------------------------------
  Rev 1.00     : Author : SKumar                       Date : 7 July 2003
  Description  : Provides presentation user-interface functions related
                 to the xformat2 chart data.

  Rev          : Author :                                 Date :
  Description  :
  --------------------------------------------------------------------------
  Note : This file contains structures required by sd_card.c & sd_block.c
**************************************************************************2*/
// TODO: get sdcard stuff outta here, rename SD generics to SD_


#if !defined G4_SD
#define G4_SD
/***********************************************************************
 *                       #define SECTION                               *
 ***********************************************************************/
#define SDCARD_MAJOR 250     
#define SDCARD_DEVS 1
#define SDCARD_MAX_DEVS 16
#define SDCARD_RAHEAD 8
#define SDCARD_BLKSIZE 1024  
#define SDCARD_HARDSECT 512  
#define SDCARD_MAX_SECTORS 1		// TODO: increase this lot? 
// connected to sd_block.c

#define SDCARD_DMA_SIZE (SDCARD_HARDSECT*SDCARD_MAX_SECTORS)	// DMA buffer allocation size

/* IMPORTANT IMPORTANT IMPORTANT IMPORTANT IMPORTANT IMPORTANT
 ** 
 **  make sure that SDCARD_HARDSECT * SDCARD_MAX_SECTORS <= SDCARD_DMA_SIZE
 */

/***********************************************************************
 *                    ERROR & WARNING CODES                            *
 ***********************************************************************/

/***********************************************************************
 *                    CONSTANTS DECLARATION SECTION                    *
 ***********************************************************************/

/***********************************************************************
 *                       TYPE DECLARATION SECTION                      *
 ***********************************************************************/

typedef struct CSD_REG
{
	__u8 csd;         /* CSD structure */
	__u8 spec_vers;   /* Spec version */
	struct
	{
		__u8 man;     /* time mantissa */
		__u8 exp;     /* time exponent */
	} taac;           /* Data read access-time-1 */
	__u8 nsac;        /* Data read access-time-2 in CLK cycle(NAC*100 */
	struct
	{
		__u8 man;     /* rate mantissa */
		__u8 exp;     /* rate exponent */
	} tran_speed;     /* Max. data transfer rate */
	__u16 ccc;        /* Card command classes */
	__u8 read_len;    /* Max. read data block length */
	__u8 read_part;   /* Partial blocks for read allowed */
	__u8 write_mis;   /* write block misalignment */
	__u8 read_mis;    /* read block misalignment */
	__u8 dsr;         /* DSR implemented */
	__u16 c_size;     /* Device size */
	__u8 vcc_r_min;   /* Max. read current at Vcc min */
	__u8 vcc_r_max;   /* Max. read current at Vcc max */
	__u8 vcc_w_min;   /* Max. write current at Vcc min */
	__u8 vcc_w_max;   /* Max. write current at Vcc max */
	__u8 c_size_mult; /* Device size multiplier */
	__u8 er_blk_en;   /* Erase block enable */
	__u8 er_sct_size; /* Erase sector size */
	__u8 wp_grp_size; /* Write protect group size */
	__u8 wp_grp_en;   /* Write protect group enable */
	__u8 r2w_factor;  /* Write speed factor */
	__u8 write_len;   /* Max. write data block length */
	__u8 write_part;  /* Partial blocks for write allowed */
	__u8 ffmt_grp;    /* File format group, rw */
	__u8 copy;        /* Copy flag (OTP), rw */
	__u8 perm_wp;     /* Permanent write protection, rw */
	__u8 tmp_wp;      /* temporary write protection, rwe */
	__u8 ffmt;        /* file format, rw */
	__u8 crc;         /* CRC, rwe */
} CSD_REG;

#include <barcelona/Barc_sd.h>


/***********************************************************************
 *                  EXTERNAL VARIABLE REFERENCES                       *
 ***********************************************************************/

/***********************************************************************
 *                  Public function prototypes                         *
 ***********************************************************************/
extern __s16 initializesdCard(void);
extern __s16 sdcardDataTransfer(__s16 cmd, __u8 *buffer, __u32 sectNo, __u32 noOfSect);
extern __u32 sdcardGetSize(void);
extern void sd_set_parm(unsigned long pclk, unsigned long gpio, unsigned long timer, unsigned long sdi);

extern int sdcard_hotswap_init(void (*func)(int),int device);
extern void sdcard_hotswap_uninit(void);


#endif  /* #if !defined G4_SD */
