/*
 * linux/drivers/h1940fb.h
 * Copyright (c) Arnaud Patard
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file COPYING in the main directory of this archive for
 * more details.
 *
 *	    iPAQ h1940/S3C2410 LCD Controller Frame Buffer Driver
 *	    based on skeletonfb.c, sa1100fb.h
 *
 * ChangeLog
 *
 * 2004-07-15: Arnaud Patard <arnaud.patard@rtp-net.org>
 *	- First version
 */


	/* Shadows for LCD controller registers */

struct sa1100fb_lcd_reg {
	unsigned long lcdcon1;
	unsigned long lcdcon2;
	unsigned long lcdcon3;
	unsigned long lcdcon4;
	unsigned long lcdcon5;
	unsigned long lcdsaddr1;
	unsigned long lcdsaddr2;
	unsigned long lcdsaddr3;
	unsigned long lpc_en;
};

struct h1940fb_info {
	struct fb_info		fb;
	struct device		*dev;

	/* raw memory addresses */
	dma_addr_t		map_dma;	/* physical */
	u_char *		map_cpu;	/* virtual */
	u_int			map_size;

	/* addresses of pieces placed in raw buffer */
	u_char *		screen_cpu;	/* virtual address of frame buffer */
	dma_addr_t		screen_dma;	/* physical address of frame buffer */

#ifdef CONFIG_LCD_DEVICE
/*	struct lcd_device       *lm;
	struct backlight_device *bm;*/
#endif
	u_int reg_lcdcon1;
	u_int reg_lcdcon2;
	u_int reg_lcdcon3;
	u_int reg_lcdcon4;
	u_int reg_lcdcon5;
	
	u_int reg_lcdsaddr1;
	u_int reg_lcdsaddr2;
	u_int reg_lcdsaddr3;
	u_int reg_lpc_en;

	u32 pseudo_pal[16];
};


