/* include/asm/arch-s3c2410/regs-adc.h
 *
 * S3C2410 ADC register definitions.
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 * Author: Dimitry Andric <dimitry.andric@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __ASM_ARCH_REGS_ADC_H
#define __ASM_ARCH_REGS_ADC_H

#define S3C2410_ADCREG(x)	((x) + S3C2410_VA_ADC)

#define S3C2410_ADCCON		S3C2410_ADCREG(0x00)
#define S3C2410_ADCTSC		S3C2410_ADCREG(0x04)
#define S3C2410_ADCDLY		S3C2410_ADCREG(0x08)
#define S3C2410_ADCDAT0		S3C2410_ADCREG(0x0c)
#define S3C2410_ADCDAT1		S3C2410_ADCREG(0x10)

#define S3C2410_ADCCON_ECFLG		(1<<15)
#define S3C2410_ADCCON_PRSCEN		(1<<14)
#define S3C2410_ADCCON_PRSCVL(x)	((x) << 6)
#define S3C2410_ADCCON_SEL_MUX(x)	((x) << 3)
#define S3C2410_ADCCON_STDBM		(1<<2)
#define S3C2410_ADCCON_READ_START	(1<<1)
#define S3C2410_ADCCON_ENABLE_START	(1<<0)

#define S3C2410_ADCDAT0_UPDOWN		(1<<15)
#define S3C2410_ADCDAT0_AUTO_PST	(1<<14)
#define S3C2410_ADCDAT0_XY_PST(x)	((x) << 12)
#define S3C2410_ADCDAT0_XPDATA(x)	((x) << 0)

#define S3C2410_ADCDAT1_UPDOWN		(1<<15)
#define S3C2410_ADCDAT1_AUTO_PST	(1<<14)
#define S3C2410_ADCDAT1_XY_PST(x)	((x) << 12)
#define S3C2410_ADCDAT1_YPDATA(x)	((x) << 0)

#endif /* __ASM_ARCH_REGS_ADC_H */

/* EOF */
