/* include/barcelona/gotype.h
 *
 * Declarations for different TomTom GO types.
 *
 * Copyright (C) 2004,2005 TomTom BV <http://www.tomtom.com/>
 * Author: Dimitry Andric <dimitry.andric@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __DRIVERS_BARCELONA_HW_GOTYPE_H
#define __DRIVERS_BARCELONA_HW_GOTYPE_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef __KERNEL__

typedef unsigned short gopin_t;

#define PORT_GPA 0x0
#define PORT_GPB 0x1
#define PORT_GPC 0x2
#define PORT_GPD 0x3
#define PORT_GPE 0x4
#define PORT_GPF 0x5
#define PORT_GPG 0x6
#define PORT_GPH 0x7
#define PORT_GPJ 0xd

#define PIN_STEP_SIZE_BITS 5
#define PIN_STEP_SIZE_MASK ((1 << PIN_STEP_SIZE_BITS) - 1)

#define PIN_NO(port,pinnr) (port * (1 << PIN_STEP_SIZE_BITS) + pinnr)

#define PIN_GPA0	PIN_NO(PORT_GPA,0)
#define PIN_GPA1	PIN_NO(PORT_GPA,1)
#define PIN_GPA2	PIN_NO(PORT_GPA,2)
#define PIN_GPA3	PIN_NO(PORT_GPA,3)
#define PIN_GPA4	PIN_NO(PORT_GPA,4)
#define PIN_GPA5	PIN_NO(PORT_GPA,5)
#define PIN_GPA6	PIN_NO(PORT_GPA,6)
#define PIN_GPA7	PIN_NO(PORT_GPA,7)
#define PIN_GPA8	PIN_NO(PORT_GPA,8)
#define PIN_GPA9	PIN_NO(PORT_GPA,9)
#define PIN_GPA10	PIN_NO(PORT_GPA,10)
#define PIN_GPA11	PIN_NO(PORT_GPA,11)
#define PIN_GPA12	PIN_NO(PORT_GPA,12)
#define PIN_GPA13	PIN_NO(PORT_GPA,13)
#define PIN_GPA14	PIN_NO(PORT_GPA,14)
#define PIN_GPA15	PIN_NO(PORT_GPA,15)
#define PIN_GPA16	PIN_NO(PORT_GPA,16)
#define PIN_GPA17	PIN_NO(PORT_GPA,17)
#define PIN_GPA18	PIN_NO(PORT_GPA,18)
#define PIN_GPA19	PIN_NO(PORT_GPA,19)
#define PIN_GPA20	PIN_NO(PORT_GPA,20)
#define PIN_GPA21	PIN_NO(PORT_GPA,21)
#define PIN_GPA22	PIN_NO(PORT_GPA,22)
#define PIN_GPA23	PIN_NO(PORT_GPA,23)
#define PIN_GPA24	PIN_NO(PORT_GPA,24)
#define PIN_GPA25	PIN_NO(PORT_GPA,25)
#define PIN_GPA26	PIN_NO(PORT_GPA,26)
#define PIN_GPA27	PIN_NO(PORT_GPA,27)
#define PIN_GPA28	PIN_NO(PORT_GPA,28)
#define PIN_GPA29	PIN_NO(PORT_GPA,29)
#define PIN_GPA30	PIN_NO(PORT_GPA,30)
#define PIN_GPA31	PIN_NO(PORT_GPA,31)

#define PIN_GPB0  PIN_NO(PORT_GPB,0)
#define PIN_GPB1  PIN_NO(PORT_GPB,1)
#define PIN_GPB2  PIN_NO(PORT_GPB,2)
#define PIN_GPB3  PIN_NO(PORT_GPB,3)
#define PIN_GPB4  PIN_NO(PORT_GPB,4)
#define PIN_GPB5  PIN_NO(PORT_GPB,5)
#define PIN_GPB6  PIN_NO(PORT_GPB,6)
#define PIN_GPB7  PIN_NO(PORT_GPB,7)
#define PIN_GPB8  PIN_NO(PORT_GPB,8)
#define PIN_GPB9  PIN_NO(PORT_GPB,9)
#define PIN_GPB10 PIN_NO(PORT_GPB,10)
#define PIN_GPB11 PIN_NO(PORT_GPB,11)
#define PIN_GPB12 PIN_NO(PORT_GPB,12)
#define PIN_GPB13 PIN_NO(PORT_GPB,13)
#define PIN_GPB14 PIN_NO(PORT_GPB,14)
#define PIN_GPB15 PIN_NO(PORT_GPB,15)

#define PIN_GPC0  PIN_NO(PORT_GPC,0)
#define PIN_GPC1  PIN_NO(PORT_GPC,1)
#define PIN_GPC2  PIN_NO(PORT_GPC,2)
#define PIN_GPC3  PIN_NO(PORT_GPC,3)
#define PIN_GPC4  PIN_NO(PORT_GPC,4)
#define PIN_GPC5  PIN_NO(PORT_GPC,5)
#define PIN_GPC6  PIN_NO(PORT_GPC,6)
#define PIN_GPC7  PIN_NO(PORT_GPC,7)
#define PIN_GPC8  PIN_NO(PORT_GPC,8)
#define PIN_GPC9  PIN_NO(PORT_GPC,9)
#define PIN_GPC10 PIN_NO(PORT_GPC,10)
#define PIN_GPC11 PIN_NO(PORT_GPC,11)
#define PIN_GPC12 PIN_NO(PORT_GPC,12)
#define PIN_GPC13 PIN_NO(PORT_GPC,13)
#define PIN_GPC14 PIN_NO(PORT_GPC,14)
#define PIN_GPC15 PIN_NO(PORT_GPC,15)

#define PIN_GPD0  PIN_NO(PORT_GPD,0)
#define PIN_GPD1  PIN_NO(PORT_GPD,1)
#define PIN_GPD2  PIN_NO(PORT_GPD,2)
#define PIN_GPD3  PIN_NO(PORT_GPD,3)
#define PIN_GPD4  PIN_NO(PORT_GPD,4)
#define PIN_GPD5  PIN_NO(PORT_GPD,5)
#define PIN_GPD6  PIN_NO(PORT_GPD,6)
#define PIN_GPD7  PIN_NO(PORT_GPD,7)
#define PIN_GPD8  PIN_NO(PORT_GPD,8)
#define PIN_GPD9  PIN_NO(PORT_GPD,9)
#define PIN_GPD10 PIN_NO(PORT_GPD,10)
#define PIN_GPD11 PIN_NO(PORT_GPD,11)
#define PIN_GPD12 PIN_NO(PORT_GPD,12)
#define PIN_GPD13 PIN_NO(PORT_GPD,13)
#define PIN_GPD14 PIN_NO(PORT_GPD,14)
#define PIN_GPD15 PIN_NO(PORT_GPD,15)

#define PIN_GPE0  PIN_NO(PORT_GPE,0)
#define PIN_GPE1  PIN_NO(PORT_GPE,1)
#define PIN_GPE2  PIN_NO(PORT_GPE,2)
#define PIN_GPE3  PIN_NO(PORT_GPE,3)
#define PIN_GPE4  PIN_NO(PORT_GPE,4)
#define PIN_GPE5  PIN_NO(PORT_GPE,5)
#define PIN_GPE6  PIN_NO(PORT_GPE,6)
#define PIN_GPE7  PIN_NO(PORT_GPE,7)
#define PIN_GPE8  PIN_NO(PORT_GPE,8)
#define PIN_GPE9  PIN_NO(PORT_GPE,9)
#define PIN_GPE10 PIN_NO(PORT_GPE,10)
#define PIN_GPE11 PIN_NO(PORT_GPE,11)
#define PIN_GPE12 PIN_NO(PORT_GPE,12)
#define PIN_GPE13 PIN_NO(PORT_GPE,13)
#define PIN_GPE14 PIN_NO(PORT_GPE,14)
#define PIN_GPE15 PIN_NO(PORT_GPE,15)

#define PIN_GPF0  PIN_NO(PORT_GPF,0)
#define PIN_GPF1  PIN_NO(PORT_GPF,1)
#define PIN_GPF2  PIN_NO(PORT_GPF,2)
#define PIN_GPF3  PIN_NO(PORT_GPF,3)
#define PIN_GPF4  PIN_NO(PORT_GPF,4)
#define PIN_GPF5  PIN_NO(PORT_GPF,5)
#define PIN_GPF6  PIN_NO(PORT_GPF,6)
#define PIN_GPF7  PIN_NO(PORT_GPF,7)
#define PIN_GPF8  PIN_NO(PORT_GPF,8)
#define PIN_GPF9  PIN_NO(PORT_GPF,9)
#define PIN_GPF10 PIN_NO(PORT_GPF,10)
#define PIN_GPF11 PIN_NO(PORT_GPF,11)
#define PIN_GPF12 PIN_NO(PORT_GPF,12)
#define PIN_GPF13 PIN_NO(PORT_GPF,13)
#define PIN_GPF14 PIN_NO(PORT_GPF,14)
#define PIN_GPF15 PIN_NO(PORT_GPF,15)

#define PIN_GPG0  PIN_NO(PORT_GPG,0)
#define PIN_GPG1  PIN_NO(PORT_GPG,1)
#define PIN_GPG2  PIN_NO(PORT_GPG,2)
#define PIN_GPG3  PIN_NO(PORT_GPG,3)
#define PIN_GPG4  PIN_NO(PORT_GPG,4)
#define PIN_GPG5  PIN_NO(PORT_GPG,5)
#define PIN_GPG6  PIN_NO(PORT_GPG,6)
#define PIN_GPG7  PIN_NO(PORT_GPG,7)
#define PIN_GPG8  PIN_NO(PORT_GPG,8)
#define PIN_GPG9  PIN_NO(PORT_GPG,9)
#define PIN_GPG10 PIN_NO(PORT_GPG,10)
#define PIN_GPG11 PIN_NO(PORT_GPG,11)
#define PIN_GPG12 PIN_NO(PORT_GPG,12)
#define PIN_GPG13 PIN_NO(PORT_GPG,13)
#define PIN_GPG14 PIN_NO(PORT_GPG,14)
#define PIN_GPG15 PIN_NO(PORT_GPG,15)

#define PIN_GPH0  PIN_NO(PORT_GPH,0)
#define PIN_GPH1  PIN_NO(PORT_GPH,1)
#define PIN_GPH2  PIN_NO(PORT_GPH,2)
#define PIN_GPH3  PIN_NO(PORT_GPH,3)
#define PIN_GPH4  PIN_NO(PORT_GPH,4)
#define PIN_GPH5  PIN_NO(PORT_GPH,5)
#define PIN_GPH6  PIN_NO(PORT_GPH,6)
#define PIN_GPH7  PIN_NO(PORT_GPH,7)
#define PIN_GPH8  PIN_NO(PORT_GPH,8)
#define PIN_GPH9  PIN_NO(PORT_GPH,9)
#define PIN_GPH10 PIN_NO(PORT_GPH,10)
#define PIN_GPH11 PIN_NO(PORT_GPH,11)
#define PIN_GPH12 PIN_NO(PORT_GPH,12)
#define PIN_GPH13 PIN_NO(PORT_GPH,13)
#define PIN_GPH14 PIN_NO(PORT_GPH,14)
#define PIN_GPH15 PIN_NO(PORT_GPH,15)

#define PIN_GPJ0  PIN_NO(PORT_GPJ,0)
#define PIN_GPJ1  PIN_NO(PORT_GPJ,1)
#define PIN_GPJ2  PIN_NO(PORT_GPJ,2)
#define PIN_GPJ3  PIN_NO(PORT_GPJ,3)
#define PIN_GPJ4  PIN_NO(PORT_GPJ,4)
#define PIN_GPJ5  PIN_NO(PORT_GPJ,5)
#define PIN_GPJ6  PIN_NO(PORT_GPJ,6)
#define PIN_GPJ7  PIN_NO(PORT_GPJ,7)
#define PIN_GPJ8  PIN_NO(PORT_GPJ,8)
#define PIN_GPJ9  PIN_NO(PORT_GPJ,9)
#define PIN_GPJ10 PIN_NO(PORT_GPJ,10)
#define PIN_GPJ11 PIN_NO(PORT_GPJ,11)
#define PIN_GPJ12 PIN_NO(PORT_GPJ,12)
#define PIN_GPJ13 PIN_NO(PORT_GPJ,13)
#define PIN_GPJ14 PIN_NO(PORT_GPJ,14)
#define PIN_GPJ15 PIN_NO(PORT_GPJ,15)

#define PIN_NOT_USED  ((gopin_t)0x8000)                     /* Pin is not used */
#define PIN_INVERTED  ((gopin_t)0x4000)                     /* Invert input or output */
#define PIN_NO_PULLUP ((gopin_t)0x2000)                     /* Don't use pullup on input or interrupt pin */
#define PIN_FLOATING (((gopin_t)0x1000) | PIN_NO_PULLUP)    /* Float pin when output is deactivated */
#define PIN_MASK      ((gopin_t)0x01ff)                     /* A maximum of 32*16=512 pins is possible */

#undef PIN_STEP_SIZE

struct gopins {
	/* SD Card Interface */
	gopin_t SD_PWR_ON;
	gopin_t SDCLK;
	gopin_t SDCMD;
	gopin_t SDDATA0;
	gopin_t SDDATA1;
	gopin_t SDDATA2;
	gopin_t SDDATA3;
	gopin_t WP_SD;
	gopin_t CD_SD;

	/* GPS interface */
	gopin_t GPS_RESET;
	gopin_t GPS_ON;
	gopin_t GPS_1PPS;
	gopin_t GPS_REPRO;

	/* Hardware detection */
	gopin_t HW_TYPE_0;
	gopin_t HW_TYPE_1;

	/* Harddisk interface */
	gopin_t HD_LED;
	gopin_t HDD_PWR_ON;
	gopin_t AT_RST;
	gopin_t HDD_BUF_EN;
	gopin_t HDD_IRQ;
	gopin_t HDD_DRQ;
	gopin_t HDD_DACK;

	/* Battery */
	gopin_t CHARGEFAULT;
	gopin_t CHARGE_OUT;
	gopin_t CHARGING;
	gopin_t AIN4_PWR;

	/* Docking */
	gopin_t DOCK_GP1;
	gopin_t DOCK_GP2;
	gopin_t DOCK_PWREN;
	gopin_t DOCKSNS0;
	gopin_t DOCKSNS1;

	/* Remote */
	gopin_t FSK_DATA_FFS;
	gopin_t FSK_IRQ;
	gopin_t SPICLK;
	gopin_t SPIMSI;
	gopin_t SPIMSO;
	gopin_t FSK_EN;
	gopin_t FSK_DCLK_FFE;
	gopin_t FSK_CLKOUT;

	/* Accelerometer */
	gopin_t ACC_PWR_ON;

	/* Sound */
	gopin_t AMP_ON;
	gopin_t DAC_PWR_ON;
	gopin_t MUTE_EXT;
	gopin_t MUTE_INT;
	gopin_t I2SSDO;
	gopin_t CDCLK;
	gopin_t I2SSCLK;
	gopin_t I2SLRCK;
	gopin_t I2SSDI;
	gopin_t L3CLOCK;
	gopin_t L3MODE;
	gopin_t L3DATA;

	/* UARTs */
	gopin_t CTS_DOCK;
	gopin_t RTS_DOCK;
	gopin_t TXD_DOCK;
	gopin_t RXD_DOCK;
	gopin_t TXD_GPS;
	gopin_t RXD_GPS;
	gopin_t TXD_BT;
	gopin_t RXD_BT;
	gopin_t RTS_BT;
	gopin_t CTS_BT;

	/* LCD */
	gopin_t VD0;
	gopin_t VD1;
	gopin_t VD2;
	gopin_t VD3;
	gopin_t VD4;
	gopin_t VD5;
	gopin_t VD6;
	gopin_t VD7;
	gopin_t VD8;
	gopin_t VD9;
	gopin_t VD10;
	gopin_t VD11;
	gopin_t VD12;
	gopin_t VD13;
	gopin_t VD14;
	gopin_t VD15;
	gopin_t VD16;
	gopin_t VD17;
	gopin_t VD18;
	gopin_t VD19;
	gopin_t VD20;
	gopin_t VD21;
	gopin_t VD22;
	gopin_t VD23;
	gopin_t VDEN;
	gopin_t VCLK;
	gopin_t LCD_VCC_PWREN;
	gopin_t LCD_BIAS_PWREN;
	gopin_t LCD_OEN;
	gopin_t BACKLIGHT_EN;
	gopin_t BACKLIGHT_PWM;

	/* USB */
	gopin_t USB_HOST_DETECT;
	gopin_t USB_PWR_EN;
	gopin_t USB_PULL_EN;
	gopin_t USB_RST;
	gopin_t SUSPEND;
	gopin_t USB_CLKOUT;

	/* Power management */
	gopin_t ON_OFF;
	gopin_t IGNITION;
	gopin_t ACPWR;

	/* Touchscreen */
	gopin_t XMON;
	gopin_t XPON;
	gopin_t YMON;
	gopin_t YPON;
};

struct gotype {
	unsigned id;
	unsigned int type;
	const char *name;
	unsigned cputype   : 2;
	unsigned bluetooth : 1;
	unsigned handsfree : 1;
	unsigned battery   : 1;
	unsigned sdcard    : 1;
	unsigned harddisk  : 1;
	unsigned tsfets    : 1;
	unsigned remote    : 1;
	struct gopins pins;
};

int IO_Init(void);

extern struct gotype gotype_current;

void IO_PowerOn(void);
void IO_PowerOff(void);
void IOP_Activate(gopin_t pin);
void IOP_Deactivate(gopin_t pin);
void IOP_SetFunction(gopin_t pin);
unsigned IOP_SetInterrupt(gopin_t pin);
unsigned IOP_SetInterruptOnActivation(gopin_t pin);
unsigned IOP_SetInterruptOnDeactivation(gopin_t pin);
void IOP_SetInput(gopin_t pin);
int IOP_GetInput(gopin_t pin);

#define IO_GetModelId()		(gotype_current.id)
#define IO_GetModelName()	(gotype_current.name)
#define IO_GetCpuType()		(gotype_current.cputype)
#define IO_HaveBluetooth()	(gotype_current.bluetooth)
#define IO_HaveLoweredButton() (gotype_current.bluetooth)
#define IO_HaveHandsfree()	(gotype_current.handsfree)
#define IO_HaveBattery()	(gotype_current.battery)
#define IO_HaveSdCard()		(gotype_current.sdcard)
#define IO_HaveHarddisk()	(gotype_current.harddisk)
#define IO_HaveTsFets()		(gotype_current.tsfets)
#define IO_HaveRemote()		(gotype_current.remote)

#define IO_Pin(x)			(gotype_current.pins.x)
#define IO_PinNr(x)			(IO_Pin(x) & PIN_MASK)
#define IO_PinNotUsed(x)	(IO_Pin(x) & PIN_NOT_USED  ? 1 : 0)
#define IO_PinUsed(x)		(IO_Pin(x) & PIN_NOT_USED  ? 0 : 1)
#define IO_PinInverted(x)	(IO_Pin(x) & PIN_INVERTED  ? 1 : 0)
#define IO_PinNoPullup(x)	(IO_Pin(x) & PIN_NO_PULLUP ? 1 : 0)
#define IO_PinPullup(x)		(IO_Pin(x) & PIN_NO_PULLUP ? 0 : 1)
#define IO_PinFloating(x)	(IO_Pin(x) & PIN_FLOATING  ? 1 : 0)

#define IO_Activate(x)						IOP_Activate(IO_Pin(x))
#define IO_Deactivate(x)					IOP_Deactivate(IO_Pin(x))
#define IO_SetFunction(x)					IOP_SetFunction(IO_Pin(x))
#define IO_SetInterrupt(x)					IOP_SetInterrupt(IO_Pin(x))
#define IO_SetInterruptOnActivation(x)		IOP_SetInterruptOnActivation(IO_Pin(x))
#define IO_SetInterruptOnDeactivation(x)	IOP_SetInterruptOnDeactivation(IO_Pin(x))
#define IO_SetInput(x)						IOP_SetInput(IO_Pin(x))
#define IO_GetInput(x)						IOP_GetInput(IO_Pin(x))

#endif /* __KERNEL__ */

/* GO type identifiers */
#define GOTYPE_M500			2		/* S3C2440, Bluetooth, harddisk, battery, handsfree */
#define GOTYPE_M300			3		/* S3C2440, Bluetooth, SD card, battery, handsfree */
#define GOTYPE_M100			5		/* S3C2410, Bluetooth, SD card, battery, no handsfree */
#define GOTYPE_HD_PROTO	6		/* S3C2410, No bluetooth, harddisk, battery, no handsfree */
#define GOTYPE_CLASSIC	7		/* S3C2410, No bluetooth, SD card, battery, no handsfree */
#define GOTYPE_SMDK2440	8		/* S3C2440, No bluetooth, SD card, no battery, no handsfree */
#define GOTYPE_BILBAO		16	/* S3C2440, Bluetooth, SD card, battery, handsfree */

/* GO CPU types */
#define GOCPU_S3C2410	1	/* Samsung S3C2410X */
#define GOCPU_S3C2440	2	/* Samsung S3C2440A */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __DRIVERS_BARCELONA_HW_GOTYPE_H */

/* EOF */
